import express from "express";
import multer from "multer";
import UploadImagemController from "../controllers/UploadImagemController.js";
import { AuthMiddleware } from "../middlewares/AuthMiddleware.js";
import ValidateUploadImagem from "../middlewares/validation/uploadImagemValidation.js";

const router = express.Router();

const upload = multer({ dest: 'uploads/' });

router
    .post('/imagens/upload', AuthMiddleware, upload.single('file'), ValidateUploadImagem.validateCriar, UploadImagemController.upload)
    .get("/imagens/:nome", UploadImagemController.buscarImagem)
    .delete("/imagens/:nome", AuthMiddleware, UploadImagemController.deleteImage)

export default router;